//+------------------------------------------------------------------+
//|                                                 SignalArrow.mq4 |                                                       
//+------------------------------------------------------------------+
#property copyright " "
#property link      " "
#property version   "2.00"
#property strict
#property description " "
#property description ""
#property description " "
#include <stderror.mqh> 
#include <stdlib.mqh> 

input string EAComment            = "SignalArrow";// EA Comment
input string Trade_Parameters     = "___________________________________________";//Trade Parameters ___________________________________________
input double StopLoss             = 30;     // Stop Loss   
input bool   ExitOpposite         = 1;      // Exit by Opposite Signal
input int    MagicNumber          = 1;      // Magic Number
input ENUM_BASE_CORNER Corner     = 1;      // Info Corner
input string MM_Settings          = "--------------------< Money Management >--------------------";//Money Management Settings ............................................................................................................
input double Lot                  = 0.01;   // Lot Size
input bool   UseRisk              = 0;      // Use Risk % Lot
input double RiskPercent          = 0.1;    // Risk %  
input string Time_Filter          = "--------------------< Time Filter >--------------------";// Time Filter ........................................................................................................... 
input bool   Use_Time_Filter      = 0;      // Use Time Filter
input string Time_Start           = "01:30";// Time Start
input string Time_End             = "19:30";// Time End
input string IndicatorsParameters = "--------------------< SignalArrow >--------------------";// SignalArrow  ....................................................
input int    Len                  = 15;
input int    TF1                  = 0;
input int    TF2                  = 0;
input int    HistoryBars          = 500;

input int    BarShift             = 0;      // Signal Bar Shift
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
double lots=0, Sloss=0, Tprof=0, ClosingArray[100], point=0.0001, DrawDowns=0, DDBuffer=0, Drawdown=0,MartinSteps=13,Multiplier=2;
int Pip=1, lotdigit=0, sh=0;
string text[26], prefix="";
bool Buy=0, Sell=0,ShowInfo=1,Martingale=0; 
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
void OnInit() 
{
   sh = BarShift;ArrayResize(text,26);
   if(MarketInfo(Symbol(),MODE_LOTSTEP)==1) lotdigit=0;
   if(MarketInfo(Symbol(),MODE_LOTSTEP)==0.1) lotdigit=1;   
   if(MarketInfo(Symbol(),MODE_LOTSTEP)==0.01) lotdigit=2;
   int digits=(int)MarketInfo(Symbol(),MODE_DIGITS);
   
   if(digits==4 || (Bid<1000 && digits==2)){ Pip=1;} else Pip=10;
   
   if(digits<=1) point = 1; //CFD & Indexes  
   if(digits==4 || digits==5) point = 0.0001; 
   if((digits==2 || digits==3) && Bid>1000) point = 1;
   if((digits==2 || digits==3) && Bid<1000) point = 0.01;
   if(StringFind(NULL,"XAU")>-1 || StringFind(NULL,"xau")>-1 || StringFind(NULL,"GOLD")>-1) point = 0.1;//Gold   
   
   return;
}  
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//  
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
  if(!IsTesting()){
  for(int i= ObjectsTotal(); i>=0; i--) 
     {
      string name= ObjectName(i);
      if(StringSubstr(name,0,4)=="Info")
        {
         ObjectDelete(name);}
        }
     }//else GVDel(prefix);
 return;
}  
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{ 
   
//+----------------------------------------------------------------------------+
   // Check History...
   if(Bars < 10){ Print("Not enough bars for working the EA");return;}
//+----------------------------------------------------------------------------+
   int err;bool ban=0,band=0;Entry();OrdersClose();
   Lots();PrintInfo();
//+----------------------------------------------------------------------------+     
   for(int i = OrdersTotal()-1; i >= 0; i--)
      {
    	if(OrderSelect (i, SELECT_BY_POS, MODE_TRADES))
    	{  
    	if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
      {      
      if(OrderOpenTime()>= iTime(NULL,0,0)) ban = true;   
    	}}} if(ban){ return;}
//+----------------------------------------------------------------------------+
   for(int i = OrdersHistoryTotal()-1; i>=0; i--)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) 
      { 
      Print("Error in history!"); break; 
      }
      if(OrderSymbol() != Symbol() || OrderType()>OP_SELL) continue;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
      {	    
      if(OrderOpenTime() >= iTime(NULL,0,0)) band = true;   
    	}} if(band){ return;}  
//+----------------------------------------------------------------------------+    	 
             //===== Check Free Margin =====\\
   if(AccountFreeMarginCheck(Symbol(), OP_BUY, lots) <= 0.0  || 
      AccountFreeMarginCheck(Symbol(), OP_SELL, lots) <= 0.0 ||  
      GetLastError() == ERR_NOT_ENOUGH_MONEY){
      Print("NOT ENOUGH MONEY TO TRADE OPEN");return;} 
      
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//       

   if(1 > Orders(-1) && GoodTime())
     {  
      if(Buy) {   
         if(StopLoss == 0){ Sloss = 0;}else{ Sloss = Bid - StopLoss * point;}
         int Ticket = OrderSend(Symbol(), OP_BUY, NL(lots), Ask, 1*Pip, Sloss, 0, EAComment, MagicNumber, 0, clrGreen);
         err = GetLastError();if(err!=ERR_NO_ERROR){ Print("Error on Order open = ", ErrorDescription(err));}
        }       
      if(Sell) {     
         if(StopLoss == 0){ Sloss = 0;}else{ Sloss = Ask + StopLoss * point;}
         int Tickets = OrderSend(Symbol(), OP_SELL, NL(lots), Bid, 1*Pip, Sloss, 0, EAComment, MagicNumber, 0, clrRed);
         err = GetLastError();if(err!=ERR_NO_ERROR){ Print("Error on Order open = ", ErrorDescription(err));}
        }        
    }                            
   return;
}    
//OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO//
//+------------------------------------------------------------------+
//|  Get Signals                                                     |
//+------------------------------------------------------------------+
double SI(int buff,int shift){ return(iCustom(NULL,0,"SignalArrow",Len,TF1,TF2,HistoryBars,6.0,233,234,2,2,clrDodgerBlue,clrCrimson,10,1,1,0,0,0,0,0,0,buff,shift));}   
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//  
//+------------------------------------------------------------------+
//| Get Entry Signals                                                | 
//+------------------------------------------------------------------+
void Entry() 
{   
   Buy = (SI(0,sh) != EMPTY_VALUE && SI(0,sh+1) == EMPTY_VALUE); 
   
   Sell= (SI(1,sh) != EMPTY_VALUE && SI(1,sh+1) == EMPTY_VALUE);
}     
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Calculate Trade Volume(Lot)                                      |
//+------------------------------------------------------------------+
void Lots()
{ 
   lots = Lot;int loss = TotalLoss();
   double LastLot=0,LotStep=0,CurrencyLotSize=0,MinLotSize=0,MaxLotSize=0;

   LotStep = MarketInfo(Symbol(),MODE_LOTSTEP); 
   CurrencyLotSize = MarketInfo(Symbol(),MODE_LOTSIZE)*MarketInfo(Symbol(),MODE_TICKVALUE);
   MaxLotSize = MarketInfo(Symbol(),MODE_MAXLOT); MinLotSize = MarketInfo(Symbol(),MODE_MINLOT);
  
   if(UseRisk){ lots = MathFloor((AccountFreeMargin()*RiskPercent/100/MarketInfo
   (Symbol(),MODE_MARGINREQUIRED))/MarketInfo(Symbol(),MODE_LOTSTEP))*MarketInfo(Symbol(),MODE_LOTSTEP);}

   if(loss==0){ LastLot = Lot;}else{ 
   LastLot = (MathRound((FindLast(-1,"lot")*Multiplier)/LotStep))*LotStep;}
         
   if(Martingale && loss <= MartinSteps){ lots = NormalizeDouble(lots * MathPow(Multiplier, loss), lotdigit);}

} 
//=================================================================================================================================================//
double NL(double L) 
{ 
  double MinLot=MarketInfo(Symbol(),MODE_MINLOT),
         MaxLot=MarketInfo(Symbol(),MODE_MAXLOT),
         LotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
        
  return( MathRound(MathMin(MathMax(L,MinLot),MaxLot)/LotStep)*LotStep ); 
}
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| get last loss                                                    |
//+------------------------------------------------------------------+
int TotalLoss()
{
   int counter=0,PrevTicket=0, CurrTicket=0;
   for(int x=0;x<=OrdersHistoryTotal()-1;x++)
      {
      bool os = OrderSelect(x,SELECT_BY_POS,MODE_HISTORY); 
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber && OrderType()<=1)
        {
         CurrTicket = OrderTicket();
         if(CurrTicket > PrevTicket) 
           {
            PrevTicket = CurrTicket;  
            if(OrderProfit() < 0) counter++;
            if(OrderProfit() > 0 || counter >= MartinSteps) counter=0;
           }}}   
   return(counter);
}    
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//   
//+------------------------------------------------------------------+
//| get last order value                                             |
//+------------------------------------------------------------------+
double FindLast(int type, string ParamName) 
{
  double mOrderPrice=0, mOrderLot=0, mOrderProfit=0;
  int PrevTicket=0, CurrTicket=0, mOrderTicket=0;

  for(int i=OrdersHistoryTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) 
         { 
         Print("Error in history!"); break; 
         }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {     
          if(OrderType() == type || type == -1){    
          CurrTicket = OrderTicket();
          if(CurrTicket > PrevTicket) 
          {
          PrevTicket = CurrTicket;         
          mOrderPrice = OrderOpenPrice();
          mOrderTicket = OrderTicket();
          mOrderLot = OrderLots();
          mOrderProfit = OrderProfit()+OrderSwap()+OrderCommission();          
        }}}}  
  if(ParamName == "price") return(mOrderPrice);
  else if(ParamName == "ticket") return(mOrderTicket);
  else if(ParamName == "lot") return(mOrderLot);
  else if(ParamName == "profit") return(mOrderProfit);
  return(0);
}  
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Close Opened Orders                                              |
//+------------------------------------------------------------------+
void OrdersClose()
{ 
   int err;
   for(int i = 0; i < OrdersTotal(); i++) 
      {
       bool OrSel = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);    
       if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
         {
          if(OrderType() == OP_BUY && ExitOpposite && Sell && iTime(NULL,0,0) > iTime(NULL,0,iBarShift(NULL,0,OrderOpenTime(),1))) 
            {
             bool close = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 0, clrBlue);CloseOrders(0); 
             err = GetLastError(); if(err!=ERR_NO_ERROR){ Print("Error on Order closing = ", ErrorDescription(err));}
            }               
          if(OrderType() == OP_SELL && ExitOpposite && Buy && iTime(NULL,0,0) > iTime(NULL,0,iBarShift(NULL,0,OrderOpenTime(),1)))   
            {
             bool close = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 0, clrRed);CloseOrders(1); 
             err = GetLastError(); if(err!=ERR_NO_ERROR){ Print("Error on Order closing = ", ErrorDescription(err));}
            }  
}   }   }
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Trade Time Settings                                              |
//+------------------------------------------------------------------+   
bool GoodTime()
{
  int hs1 = StrToInteger(StringSubstr(Time_Start, 0, 2)), ms1 = StrToInteger(StringSubstr(Time_Start, 3, 2));
  int he1 = StrToInteger(StringSubstr(Time_End, 0, 2)), me1 = StrToInteger(StringSubstr(Time_End, 3, 2));

  if(!Use_Time_Filter)return(true);
  
  if(Use_Time_Filter && hs1 < he1)
    {
    if(((TimeHour(TimeCurrent()) == hs1 && TimeMinute(TimeCurrent()) >= ms1) && TimeHour(TimeCurrent()) < he1) 
    || (TimeHour(TimeCurrent()) > hs1 && TimeHour(TimeCurrent()) < he1) 
    || ((TimeMinute(TimeCurrent()) <= me1 && TimeHour(TimeCurrent()) == he1) && TimeHour(TimeCurrent()) > hs1) 
    || (TimeHour(TimeCurrent()) < he1 && TimeHour(TimeCurrent()) > hs1))
    return(true);
    }
  if(Use_Time_Filter && hs1 > he1)
    {
    if((TimeHour(TimeCurrent()) == hs1 && TimeMinute(TimeCurrent()) >= ms1 && TimeHour(TimeCurrent()) < 24)
    || (TimeHour(TimeCurrent()) > hs1 && TimeHour(TimeCurrent()) < 24)
    || (TimeHour(TimeCurrent()) == he1 && TimeMinute(TimeCurrent()) <= me1 && TimeHour(TimeCurrent()) >= 0)
    || (TimeHour(TimeCurrent()) < he1 && TimeHour(TimeCurrent()) >= 0))
    return(true);
    }    
   return(false);   
} 
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------------+
//| Get total order                                                  |
//+------------------------------------------------------------------+
int Orders(int type)
{
   int count=0;
   //-1= All,0=Buy,1=Sell,2=BuyLimit,3=SellLimit,4=BuyStop,5=SellStop,6=AllBuy,7=AllSell,8=AllMarket,9=AllPending;   
   for(int x=OrdersTotal()-1;x>=0;x--)
      {
      if(OrderSelect(x,SELECT_BY_POS,MODE_TRADES)){ 
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) 
        {
         if(type < 0){ count++;}
         if(OrderType() == type && type >= 0){ count++;}  
         if(OrderType() <= 1 && type == 8){ count++;}  
         if(OrderType() > 1 && type == 9){ count++;}  
         if((OrderType() == 0 || OrderType() == 2 || OrderType() == 4) && type == 6){ count++;}
         if((OrderType() == 1 || OrderType() == 3 || OrderType() == 5) && type == 7){ count++;}       
        }}}   
   return(count);
}
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
//+------------------------------------------------------------+
//|  Close Orders                                              |
//+------------------------------------------------------------+  
bool CloseOrders(int type)
{ //-1= All,0=Buy,1=Sell,2=BuyLimit,3=SellLimit,4=BuyStop,5=SellStop,6=All Buys,7=All Sells,8=All Market,9=All Pending;
  bool oc=0;    
  for(int i=OrdersTotal()-1;i>=0;i--){
  bool os = OrderSelect(i,SELECT_BY_POS, MODE_TRADES);
  if(OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
    {   
     if(type==-1){
     if(OrderType()==0){ oc = OrderClose(OrderTicket(),OrderLots(),Bid,1000,clrGold);}
     if(OrderType()==1){ oc = OrderClose(OrderTicket(),OrderLots(),Ask,1000,clrGold);}      
     if(OrderType()>1){ oc = OrderDelete(OrderTicket());}}  
     if(OrderType()>1 && type==9){ oc = OrderDelete(OrderTicket());} 
     if(OrderType()<=1 && type==8){ oc = OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),1000,clrGold);}
     if(OrderType()==type && type==0){ oc = OrderClose(OrderTicket(),OrderLots(),Bid,1000,clrGold);}
     if(OrderType()==type && type==1){ oc = OrderClose(OrderTicket(),OrderLots(),Ask,1000,clrGold);} 
     if(OrderType()==type && OrderType()> 1){ oc = OrderDelete(OrderTicket());} 
     if(OrderType()==0 && type==6){ oc = OrderClose(OrderTicket(),OrderLots(),Bid,1000,clrGold);}  
     if((OrderType()==2 || OrderType()== 4) && type==6){ oc = OrderDelete(OrderTicket());}   
     if(OrderType()==1 && type==7){ oc = OrderClose(OrderTicket(),OrderLots(),Bid,1000,clrGold);}  
     if((OrderType()==3 || OrderType()== 5) && type==7){ oc = OrderDelete(OrderTicket());}       
     for(int x=0;x<100;x++)
     {
      if(ClosingArray[x]==0)
      {
       ClosingArray[x]=OrderTicket();
       break; } } } }
   return(oc);
}      
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~+
double ND(double price)
{
   if(price > 0)return(NormalizeDouble(price,_Digits));
   return(0);
}
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH// 
//+------------------------------------------------------------------+
//| Print info to chart                                              |
//+------------------------------------------------------------------+
void PrintInfo()
{
  string Current = "NO ORDER";
  
  if(CurrentProfit()!=0){ Current = DoubleToStr(CurrentProfit(),2);}
  
  if(AccountBalance()!=0){ DrawDowns = DrawDown()*100.0/AccountBalance();}
    
  if(ShowInfo){    
    text[1]= EAComment;
    text[2]= "-------------------------------------------";
    text[3]= "Time Current: " + TimeToStr(TimeCurrent());
    text[4]= "-------------------------------------------";    
    text[5]= "Account Number: " + IntegerToString(AccountNumber());
    text[6]= "Account Leverage: " + IntegerToString(AccountLeverage());
    text[7]= "Account Balance: " + DoubleToStr(AccountBalance(), 2);
    text[8]= "Account Equity: " + DoubleToStr(AccountEquity(), 2);
    text[9]= "Free Margin: " + DoubleToStr(AccountFreeMargin(), 2);
    text[10]= "Used Margin: " + DoubleToStr(AccountMargin(), 2);
    text[11]= "Max. Draw Down: " + DoubleToStr(DrawDown(), 2)+"("+DoubleToStr(DrawDowns,2)+"%"")";
    text[12]= "Account Today Profit: " + DoubleToStr(DailyProfits(), 2);
    text[13]= "-------------------------------------------";
    text[14]= "Lot Size: " + DoubleToStr(lots,lotdigit);
    text[15]= "Stop Loss: " + DoubleToStr(StopLoss,0);    
    text[16]= "Current Profit: " + Current;     
    text[17]= "-------------------------------------------";
    
    int i=1, k=20;
    while (i<=19)
    {
       string ChartInfo = "Info"+IntegerToString(i);
       ObjectCreate(ChartInfo, OBJ_LABEL, 0, 0, 0);
       ObjectSetText(ChartInfo, text[i], 9, "Arial", Aqua);
       ObjectSet(ChartInfo, OBJPROP_CORNER, Corner);   
       ObjectSet(ChartInfo, OBJPROP_XDISTANCE, 7);  
       ObjectSet(ChartInfo, OBJPROP_YDISTANCE, k);
       i++;
       k=k+13;
    }
  }
}
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//   
//+----------------------------------------------------------------------------------+
//| Daily Profit                                                                     |
//+----------------------------------------------------------------------------------+  
double DailyProfits()
{   
   int i; double LastDayProfits=0;
   for(i=0;i<OrdersHistoryTotal();i++)
    {
     bool os = OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
     if(OrderMagicNumber()==MagicNumber && TimeDayOfYear(OrderCloseTime())==DayOfYear()){
     LastDayProfits=LastDayProfits+OrderProfit()+OrderSwap()+OrderCommission();}}
  
   for(i = 0; i < OrdersTotal(); i++) 
    {
     bool Os = OrderSelect(i,SELECT_BY_POS, MODE_TRADES); 
     if(OrderMagicNumber()==MagicNumber && TimeDayOfYear(OrderOpenTime())==DayOfYear()){
     LastDayProfits=LastDayProfits+OrderProfit()+OrderSwap()+OrderCommission();
   }}       
  return(LastDayProfits);
}
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//   
//+----------------------------------------------------------------------------------+
//| Current Profit                                                                   |
//+----------------------------------------------------------------------------------+  
double CurrentProfit()
{   
   double Profit=0;
   for(int i = 0;i < OrdersTotal();i++) 
      {
       bool Os = OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber){
       Profit=Profit+OrderProfit()+OrderSwap()+OrderCommission();}
      }       
  return(Profit);
}  
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//   
//+----------------------------------------------------------------------------------+
//| Get Draw Down                                                                    |
//+----------------------------------------------------------------------------------+
double DrawDown()
{
   double DD=AccountBalance()-AccountEquity();
   if(DD>DDBuffer)DDBuffer=DD;
   return(DDBuffer);
} 
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//

                                                                        //| THE END |\\  
 
//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH//
